/////////////////////////////////////////////////////////////////////////////
// Project:     wxIView
// Purpose:     Complex wxWidgets sample
// Name:        wxextfiledroptarget.cpp
// Author:      Daniel Nell
// Created:     2006/02/16
// Copyright:   (c) Daniel Nell
// Licence:     wxWindows license
// Modified by:
/////////////////////////////////////////////////////////////////////////////

// For compilers that support precompilation, includes "wx/wx.h".
#include <wx/wxprec.h>
#ifndef WX_PRECOMP
#   include <wx/wx.h>
#endif

// Include private wxIView headers.
#include "wxextfiledroptarget.h"


//////////////////////////////////////////////////////////
// Class wxExtFileDropTarget
//
DEFINE_EVENT_TYPE( wxEVT_EXTFILEDROP )

// Handler for file dropping.
//
bool wxExtFileDropTarget::OnDropFiles( wxCoord WXUNUSED( x ),
                                       wxCoord WXUNUSED( y ),
                                       const wxArrayString& astrFilenames )
{
    // Check if there is a valid owner window.
    if( m_poOwner == NULL )
    {
        // Otherwise quit and signal an error.
        return false;
    }

    // File drop event to post to the owner window.
    wxExtFileDropEvent oEvent;

    // Get the number of items that are to be dropped...
    unsigned nCount= astrFilenames.GetCount();

    // ... and open them one by one using the owner window's event process chain.
    for( unsigned i= 0; i < nCount; i++ )
    {
        // Forward a file drop event with the current file name to the owner window.
        oEvent.SetFileName( astrFilenames[i] );

        m_poOwner->ProcessEvent( oEvent );
    }

    // Signal success.
    return true;
}
