/////////////////////////////////////////////////////////////////////////////
// Project:     wxSQuery
// Purpose:     ...
// Name:        wxtextctrlcolourizer.h
// Author:      Daniel Nell
// Created:     2012/02/12
// Copyright:   (c) Daniel Nell
// Licence:     wxWindows licence
// Modified by:
/////////////////////////////////////////////////////////////////////////////

#ifndef __WXTEXTCTRLCOLOURIZER_H
#define __WXTEXTCTRLCOLOURIZER_H

/////////////////////////////////////////////////////////////////////////////
//  Class wxTextCtrlColourizer
//
/// \brief ...
///
/// ...
class wxTextCtrlColourizer
{
  public:
    /// Default constructor
    wxTextCtrlColourizer( wxTextCtrl *poTextCtrl, const wxColour &oColour )
    {
        m_poTextCtrl= poTextCtrl;
        if( m_poTextCtrl )
        {
            wxTextAttr oStyle( m_poTextCtrl->GetDefaultStyle() );

            m_oDefaultTextColour= oStyle.GetTextColour();
            oStyle.SetTextColour( oColour );
            m_poTextCtrl->SetDefaultStyle( oStyle );
        }
    }

    /// Destructor
    virtual ~wxTextCtrlColourizer()
    {
        if( m_poTextCtrl )
        {
            wxTextAttr oStyle( m_poTextCtrl->GetDefaultStyle() );

            oStyle.SetTextColour( m_oDefaultTextColour );
            m_poTextCtrl->SetDefaultStyle( oStyle );
        }
    }

  protected:
    wxTextCtrl *m_poTextCtrl;                           ///< ...
    wxColour m_oDefaultTextColour;                      ///< ...
};

#endif // __WXTEXTCTRLCOLOURIZER_H
